macro clone {
  rule {
    array $subject as $target;
  } => {
    var source = $subject,
        length = source.length,
        $target = new Array(length),
        i;
    for (i = 0; i < length; i++) {
      $target[i] = source[i];
    }
  }
  rule {
    object $subject as $target;
  } => {
    var source = $subject,
        keys = Object.keys(source),
        length = keys.length,
        $target = {},
        key, i;
    for (i = 0; i < length; i++) {
      key = keys[i];
      $target[key] = source[key];
    }
  }
}

clone array "hello world" as items;
clone object {foo: "bar"} as obj;